## lilypond-2.5.15.tar.gz

=== SConstruct ===
# -*-python-*-

'''
Experimental scons (www.scons.org) building.

Usage

    scons TARGET

build from source directory ./TARGET (not recursive)

Configure, build

    scons [config]             # configure
    scons                      # build all

Run from build tree

    run=$(pwd)/out-scons/usr
    export LOCALE=$run/share/locale
    export TEXMF='{'$run/share/lilypond,$(kpsexpand '$TEXMF')'}'
    PATH=$run/bin:$PATH

    #optionally, if you do not use custom.py below
    #export LILYPONDPREFIX=$run/share/lilypond

    lilypond-bin input/simple

Other targets
    scons mf-essential         # build minimal mf stuff

    scons doc                  # build web doc
    scons config               # reconfigure
    scons install              # install
    scons -c                   # clean
    scons -h                   # help

    scons /                    # build *everything* (including installation)

Options  (see scons -h)
    scons build=DIR            # clean srcdir build, output below DIR
    scons out=DIR              # write output for alterative config to DIR

Debugging
    scons --debug=dtree
    scons --debug=explain
    scons verbose=1

Optional custom.py

import os
out='out-scons'
optimising=0
debugging=1
gui=1
os.path.join (os.getcwd (), '=install')
prefix=os.path.join (os.environ['HOME'], 'usr', 'pkg', 'lilypond')

'''


# TODO:
#  * usability

#  * more program configure tests (mfont, ...?)

#  * install doc

#  * split doc target: doc input examples mutopia?

#  * grep FIXME $(find . -name 'S*t')


import re
import glob
import os
import string
import sys
import stat
import shutil

# duh, we need 0.95.1
EnsureSConsVersion (0, 95)

usage = r'''Usage:
scons [KEY=VALUE].. [TARGET|DIR]..

TARGETS: clean, config, doc, dist, install, mf-essential, po-update,
         realclean, release, sconsclean, tar, TAGS

'''
      

config_cache = 'scons.cache'

config_vars = [
	'BASH',
	'CCFLAGS',
	'CPPPATH',
	'CPPDEFINES',
	'CXXFLAGS',
	'DEFINES',
	'LIBS',
	'LINKFLAGS',
	'METAFONT',
	'PERL',
	'PYTHON',
	]

# Put your favourite stuff in custom.py
opts = Options ([config_cache, 'custom.py'], ARGUMENTS)
opts.Add ('prefix', 'Install prefix', '/usr/')
opts.Add ('out', 'Output directory', 'out-scons')
opts.Add ('build', 'Build directory', '.')
opts.Add ('DESTDIR', 'DESTDIR prepended to prefix', '')
opts.AddOptions (
	BoolOption ('warnings', 'compile with -Wall and similiar',
		   1),
	BoolOption ('debugging', 'compile with debugging symbols',
		    0),
	BoolOption ('optimising', 'compile with optimising',
		    1),
	BoolOption ('shared', 'build shared libraries',
		    0),
	BoolOption ('static', 'build static libraries',
		    1),
	BoolOption ('gui', 'build with GNOME backend (EXPERIMENTAL)',
		    1),
	BoolOption ('verbose', 'run commands with verbose flag',
		    0),
	BoolOption ('checksums', 'use checksums instead of timestamps',
		    0),
	BoolOption ('fast', 'use timestamps, implicit cache, prune CPPPATH',
		    1),
	)

srcdir = Dir ('.').srcnode ().abspath
#ugh
sys.path.append (os.path.join (srcdir, 'stepmake', 'bin'))
import packagepython
package = packagepython.Package (srcdir)
version = packagepython.version_tuple_to_str (package.version)

ENV = { 'PATH' : os.environ['PATH'] }
for key in ['LD_LIBRARY_PATH', 'GUILE_LOAD_PATH', 'PKG_CONFIG_PATH']:
    	if os.environ.has_key (key):
        	ENV[key] = os.environ[key]

env = Environment (
	ENV = ENV,

	BASH = '/bin/bash',
	CPPDEFINES = '-DHAVE_CONFIG_H',
	PERL = '/usr/bin/perl',
	PYTHON = '/usr/bin/python',
	SH = '/bin/sh',

	MAKEINFO = 'LANG= makeinfo',
	MF_TO_TABLE_PY = srcdir + '/buildscripts/mf-to-table.py',
	
	PKG_CONFIG_PATH = [os.path.join (os.environ['HOME'],
					 'usr/pkg/gnome/lib'),
			   os.path.join (os.environ['HOME'],
					 'usr/pkg/pango/lib')],
	GZIP='-9v',
	MFMODE = 'ljfour',
	TOPLEVEL_VERSION = version,
	)

# Add all config_vars to opts, so that they will be read and saved
# together with the other configure options.
map (lambda x: opts.AddOptions ((x,)), config_vars)

Help (usage + opts.GenerateHelpText (env))

opts.Update (env)

if env['fast']:
	# Usability switch (Anthony Roach).
	# See http://www.scons.org/cgi-bin/wiki/GoFastButton
	# First do: scons realclean .
	env['checksums'] = 0
	SetOption ('max_drift', 1)
	SetOption ('implicit_cache', 1)
elif env['checksums']:
	# Always use checksums (makes more sense than timestamps).
	SetOption ('max_drift', 0)
	# Using *content* checksums prevents rebuilds after
	# [re]configure if config.hh has not changed.  Too bad that it
	# is unusably slow.
	TargetSignatures ('content')

absbuild = Dir (env['build']).abspath
outdir = os.path.join (Dir (env['build']).abspath, env['out'])
run_prefix = os.path.join (absbuild, os.path.join (env['out'], 'usr'))


config_hh = os.path.join (outdir, 'config.hh')
version_hh = os.path.join (outdir, 'version.hh')

env.Alias ('config', config_cache)

cachedir = os.path.join (outdir, 'build-cache')

if not os.path.exists (cachedir):
	os.makedirs (cachedir)

CacheDir (cachedir)

# No need to set $LILYPONDPREFIX to run lily, but cannot install...
if env['debugging'] and not 'install' in COMMAND_LINE_TARGETS:
	env['prefix'] = run_prefix

prefix = env['prefix']
bindir = os.path.join (prefix, 'bin')
sharedir = os.path.join (prefix, 'share')
libdir = os.path.join (prefix, 'lib')
localedir = os.path.join (sharedir, 'locale')
sharedir_doc_package = os.path.join (sharedir, 'doc', package.name)
sharedir_package = os.path.join (sharedir, package.name)
sharedir_package_version = os.path.join (sharedir_package, version)
lilypondprefix = sharedir_package_version

# junkme
env.Append (
	absbuild = absbuild,
	srcdir = srcdir,
	)


def list_sort (lst):
	sorted = lst
	sorted.sort ()
	return sorted


def configure (target, source, env):
	vre = re.compile ('^.*[^-.0-9]([0-9][0-9]*\.[0-9][.0-9]*).*$', re.DOTALL)
	def get_version (program):
		command = '(%(program)s --version || %(program)s -V) 2>&1' % vars ()
		pipe = os.popen (command)
		output = pipe.read ()
		if pipe.close ():
			return None
		v = re.sub (vre, '\\1', output)
		return string.split (v, '.')

	def test_program (lst, program, minimal, description, package):
		sys.stdout.write ('Checking %s version... ' % program)
		actual = get_version (program)
		if not actual:
			print 'not found'
			lst.append ((description, package, minimal, program,
				     'not installed'))
			return
		sys.stdout.write (string.join (actual, '.'))
		sys.stdout.write ('\n')
		if actual < string.split (minimal, '.'):
			lst.append ((description, package, minimal, program,
				     string.join (actual, '.')))

	for i in ['bash', 'perl', 'python', 'sh']:
		sys.stdout.write ('Checking for %s... ' % i)
		c = WhereIs (i)
		key = string.upper (i)
		if c:
			env[key] = c
			sys.stdout.write (c)
		else:
			sys.stdout.write ('not found: %s (using: %s)' \
					  % (c, env[key]))
			# Hmm? abort?
		sys.stdout.write ('\n')

	required = []
	test_program (required, 'gcc', '2.8', 'GNU C compiler', 'gcc')
	test_program (required, 'g++', '3.0.5', 'GNU C++ compiler', 'g++')
	test_program (required, 'python', '2.1', 'Python (www.python.org)', 'python')
	test_program (required, 'guile-config', '1.6', 'GUILE development',
			'libguile-dev or guile-devel')
	# Do not use bison 1.50 and 1.75.
	test_program (required, 'bison', '1.25', 'Bison -- parser generator',
			'bison')
	test_program (required, 'flex', '0.0', 'Flex -- lexer generator', 'flex')


	optional = []
	test_program (optional, 'makeinfo', '4.7', 'Makeinfo tool', 'texinfo')
	test_program (optional, 'guile', '1.6', 'GUILE scheme',
			'libguile-dev or guile-devel')
	test_program (optional, 'mftrace', '1.0.27', 'Metafont tracing Type1',
			'mftrace')
	test_program (optional, 'perl', '4.0',
			'Perl practical efficient readonly language', 'perl')
	#test_program (optional, 'foo', '2.0', 'Foomatic tester', 'bar')

	def CheckYYCurrentBuffer (context):
		context.Message ('Checking for yy_current_buffer... ')
		ret = conf.TryCompile ("""using namespace std;
		#include <FlexLexer.h>
		class yy_flex_lexer: public yyFlexLexer
		{
		public:
		yy_flex_lexer ()
		{
		yy_current_buffer = 0;
		}
		};""", '.cc')
		context.Result (ret)
		return ret

	conf = Configure (env, custom_tests = { 'CheckYYCurrentBuffer'
						: CheckYYCurrentBuffer })

	defines = {
	   'DIRSEP' : "'%s'" % os.sep,
	   'PATHSEP' : "'%s'" % os.pathsep,
	   'TOPLEVEL_VERSION' : '"' + version + '"',
	   'PACKAGE': '"' + package.name + '"',
	   'DATADIR' : '"' + sharedir + '"',
	   'LILYPOND_DATADIR' : '"' + sharedir_package + '"',
	   'LOCAL_LILYPOND_DATADIR' : '"' + sharedir_package_version + '"',
	   'LOCALEDIR' : '"' + localedir + '"',
	}
	conf.env.Append (DEFINES = defines)

	command = r"""python -c 'import sys; sys.stdout.write ("%s/include/python%s" % (sys.prefix, sys.version[:3]))'""" #"
	PYTHON_INCLUDE = os.popen (command).read ()
	if env['fast']:
		env.Append (CCFLAGS = ['-I%s ' % PYTHON_INCLUDE])
	else:
		env.Append (CPPPATH = PYTHON_INCLUDE)

	headers = ('sys/stat.h', 'assert.h', 'kpathsea/kpathsea.h', 'libio.h',
		   'Python.h')
	for i in headers:
		if conf.CheckCHeader (i):
			key = re.sub ('[./]', '_', 'HAVE_' + string.upper (i))
			conf.env['DEFINES'][key] = 1

	ccheaders = ('sstream',)
	for i in ccheaders:
		if conf.CheckCXXHeader (i):
			key = re.sub ('[./]', '_', 'HAVE_' + string.upper (i))
			conf.env['DEFINES'][key] = 1

	functions = ('fopencookie', 'funopen',
		     'gettext', 'isinf', 'memmem', 'snprintf', 'vsnprintf')
	for i in functions:
		if 0 or conf.CheckFunc (i):
			key = re.sub ('[./]', '_', 'HAVE_' + string.upper (i))
			conf.env['DEFINES'][key] = 1

	if conf.CheckYYCurrentBuffer ():
		conf.env['DEFINES']['HAVE_FLEXLEXER_YY_CURRENT_BUFFER'] = 1

	if conf.CheckLib ('dl'):
		pass

	if conf.CheckLib ('kpathsea'):
		conf.env['DEFINES']['KPATHSEA'] = 1

	# huh? 
	if conf.CheckLib ('kpathsea', 'kpse_find_file'):
		conf.env['DEFINES']['HAVE_KPSE_FIND_FILE'] = '1'
	if conf.CheckLib ('kpathsea', 'kpse_find_tfm'):
		conf.env['DEFINES']['HAVE_KPSE_FIND_TFM'] = '1'

	# FIXME fc3 - move to kpath-guile/SConscript?
	conf.env['DEFINES']['HAVE_LIBKPATHSEA_SO'] = '1'

	if env['fast']:
		cpppath = []
		if env.has_key ('CPPPATH'):
			cpppath = env['CPPPATH']

	## FIXME: linkage, check for libguile.h and scm_boot_guile
	#this could happen after flower...
	env.ParseConfig ('guile-config compile')

	## FIXME: pkg-test to required/optional
	if os.system ('pkg-config --atleast-version=1.6.0 pango'):
		barf
	env.ParseConfig ('pkg-config --cflags --libs pango')
	conf.env['DEFINES']['HAVE_PANGO16'] = '1'
	
	if os.system ('pkg-config --atleast-version=1.6.0 pangoft2'):
		barf
	env.ParseConfig ('pkg-config --cflags --libs pangoft2')
	conf.env['DEFINES']['HAVE_PANGO_FT2'] = '1'
	
	#this could happen only for compiling pango-*
	if env['gui']:
		env.ParseConfig ('pkg-config --cflags --libs gtk+-2.0')
		env.ParseConfig ('pkg-config --cflags --libs pango')
		if conf.CheckCHeader ('pango/pangofc-fontmap.h'):
			conf.env['DEFINES']['HAVE_PANGO_PANGOFC_FONTMAP_H'] = '1'

		if conf.CheckLib ('pango-1.0',
				  'pango_fc_font_map_add_decoder_find_func'):
			conf.env['DEFINES']['HAVE_PANGO_CVS'] = '1'
			conf.env['DEFINES']['HAVE_PANGO_FC_FONT_MAP_ADD_DECODER_FIND_FUNC'] = '1'

	if env['fast']:
		# Using CCFLAGS = -I<system-dir> rather than CPPPATH = [
		# <system-dir>] speeds up SCons
		env['CCFLAGS'] += map (lambda x: '-I' + x,
				       env['CPPPATH'][len (cpppath):])
		env['CPPPATH'] = cpppath

	if required:
		print
		print '********************************'
		print 'Please install required packages'
		for i in required:
			print '%s:	%s-%s or newer (found: %s %s)' % i
		Exit (1)

	if optional:
		print
		print '*************************************'
		print 'Consider installing optional packages'
		for i in optional:
			print '%s:	%s-%s or newer (found: %s %s)' % i

	return conf.Finish ()

def config_header (target, source, env):
	config = open (str (target[0]), 'w')
	for i in list_sort (env['DEFINES'].keys ()):

=== debian/control ===
Source: lilypond
Build-Depends: debhelper (>= 4.0.0), binutils (>= 2.11.92.0.10-2), libc6-dev (>= 2.2.4-6) | libc6.1-dev (>= 2.2.4-6) | libc0.2-dev (>= 2.2.4-6), python-dev, guile-1.6-dev | libguile-dev, tetex-bin, libkpathsea-dev, tetex-extra, flex (>= 2.5.4a-14) | flex-old, bison (<< 1:1.50) | bison (>> 1:1.75-1), texinfo (>= 4.6-1), groff, m4, gettext (>= 0.10.36-1), mftrace (>= 1.0.17-1), fontforge | pfaedit (>= 0.0.20031020-3), t1utils, imagemagick (>= 5.4.4.5)
Build-Depends-Indep: gs-esp | gs (<= 7.07-1), netpbm (>= 2:9.10-1)
Build-Conflicts-Indep: gs-gpl (>= 8.01) | gs-afpl
Section: tex
Priority: optional
Maintainer: Anthony Fok <foka@debian.org>
Standards-Version: 3.6.1

Package: lilypond
Architecture: any
Replaces: lilypond1.3
Provides: lilypond1.3
Depends: ${shlibs:Depends}, tetex-bin (>= 1.0.5-1), tetex-extra (>= 1.0-1), python, guile-1.6 | guile, ${misc:Depends}, lilypond-data (= ${Source-Version})
# , ec-fonts-mftraced (>= 1.0.5-1)
Recommends: lilypond-doc
Conflicts: lilypond1.3 (<= 1.3.132-1), musixtex-fonts
Description: A program for typesetting sheet music
 LilyPond is a music typesetter, an automated engraving system.  It
 produces beautiful sheet music using a high level description file as input.
 .
 LilyPond supports many forms of music notation constructs, including
 chord names, drum notation, figured bass, grace notes, guitar tablature,
 modern notation (cluster notation and rhythmic grouping), tremolos,
 (nested) tuplets in arbitrary ratios, and more.
 .
 LilyPond's text-based music input language support can integrate into
 LaTeX, HTML and Texinfo seemlessly, allowing single sheet music
 or musicological treatises to be written from a single source.  Form and
 content are separate, and with LilyPond's expert automated formatting,
 users don't need typographical expertise to produce good notation.
 .
 LilyPond produces PostScript and PDF (via TeX) printed output, as well
 as MIDI for listening pleasures.  LilyPond is exported from the
 RoseGarden and NoteEdit GUIs, and can import ABC, ETF and MIDI.
 .
 LilyPond is part of the GNU Project.
 .
  Home Page: http://lilypond.org/
  Authors: Han-Wen Nienhuys <hanwen@cs.uu.nl>
           Jan Nieuwenhuizen <janneke@gnu.org>

Package: lilypond-data
Section: tex
Architecture: all
Depends: tetex-bin
Recommends: lilypond (= ${Source-Version})
Conflicts: lilypond (<< 2.2.2-2)
Description: LilyPond music typesetter (data files)
 LilyPond is a music typesetter, an automated engraving system.  It
 produces beautiful sheet music using a high level description file as input.
 . 
 This package contains architecture-independent data files for LilyPond.

Package: lilypond-doc
Section: doc
Architecture: all
Suggests: lilypond (>= ${Source-Version}), gv | postscript-viewer, mozilla-browser | www-browser
Replaces: lilypond (<= 2.2.3-1), lilypond-data (<= 2.2.3-1)
Description: LilyPond Documentation in HTML, PS and DVI formats
 This package contains the HTML, PostScript and DVI documentation for the
 LilyPond music typesetting software.

Package: lilypond1.3
Architecture: arm i386 m68k powerpc sparc
Depends: lilypond (>= ${Source-Version})
Description: Dummy package for transition to new stable lilypond
 This dummy package provides a transition from the previous lilypond1.3
 package back to a newer lilypond stable releases.
 .
 Please feel free to remove this dummy package after you have upgraded
 to the latest lilypond.
